function love.conf(t)
  t.title = "Resolution Changer"
  t.author = "Nicholas Carlson"

  local tiny = {
    fullscreen = {
      fullscreen = true,
      width = 640,
      height = 480
    },
    windowed = {
      fullscreen = false,
      width = 640,
      height = 480
    }
  }


  local laptop = {
    fullscreen = {
      fullscreen = true,
      width = 1366,
      height = 768
    },
    windowed = {
      fullscreen = false,
      width = 1152,
      height = 648
    }
  }

  local desktop = {
    fullscreen = {
      fullscreen = true,
      width = 1920,
      height = 1080
    },
    windowed = {
      fullscreen = false,
      width = 1280,
      height = 720
    }
  }

  t.screen = laptop.windowed

  t.screen.vsync = false
  t.screen.fsaa = 0

  t.modules.audio = true
  t.modules.keyboard = true
  t.modules.event = true
  t.modules.image = true
  t.modules.graphics = true
  t.modules.timer = true
  t.modules.mouse = true
  t.modules.sound = true
  t.modules.physics = true
  t.modules.filesystem = true


  t.console = true

  -- global variable
  gWindow = {
    width = t.screen.width,
    height = t.screen.height
  }

end
