return function (state)

  function state:init()
    self.drawGrid = false

    self.colors = require 'lib.colors'
    self.gui = require 'lib.quickie'
    self.grid = require 'lib.quickie.grid'

    self.debugName = "Credits"
    -- print("init:\t\t " .. self.debugName)
  end

  function state:enter(previous)
    local gridschema = {
      columns = { 200, 230, 200 },
      rows = { 100, 20, 60, 60, 30, 10, 30, 10, 30 },
      alignment = {
        horizontal = "center",
        vertical = "top"
      },
      margin = { left = 0, top = 130, right = 0, bottom = 0 }
    }
    self.grid:init(self.gui, gridschema)
  end

  function state:leave(previous)
    self.doExit = nil
  end

  function state:update(dt)
    if self.doExit then return self.doExit() end

    if self.grid:Button("Done", 2, 9, 1, 1, "menu") then
      self.doExit = function () return self.parent end
    end
  end

  function state:draw()
    self.gui.core.draw()

    if self.drawGrid then self.grid:TestDrawGrid() end
  end


  function state:keypressed(key, code)
    self.gui.core.keyboard.pressed(key, code)
    if key == "escape" then
      self.doExit = function () return self.parent end
    end

    if key == "g" then
      self.drawGrid = not self.drawGrid
    end

    -- print("keypressed:\t " .. self.debugName, key, code)
  end

  return state

end
