return function (state)

  function state:init()
    self.drawGrid = false

    self.colors = require 'lib.colors'
    self.gui = require 'lib.quickie'
    self.grid = require 'lib.quickie.grid'


    self.debugName = "Title"
    -- print("init:\t\t " .. self.debugName)
  end

  function state:enter(previous)
    local gridschema = {
      columns = {150, 10, 150, 10, 150, 10, 150 },
      rows = { 100, 20, 60, 40, 30, 10, 30, 10, 30 },
      alignment = {
        horizontal = "center",
        vertical = "top"
      },
      margin = { left = 0, top = 130, right = 0, bottom = 0 }
    }
    self.grid:init(self.gui, gridschema)
    -- print("enter:\t\t " .. self.debugName)
  end

  function state:leave(previous)
    self.doExit = nil
    -- print("leave:\t\t " .. self.debugName .. "\n")
  end

  function state:update(dt)
    if self.doExit then return self.doExit() end

    local top = 50

    self.grid:Label("GAME TITLE", 1, 1, 7, 1, 'center', "title")
    self.grid:Label("with a witty subtitle", 3, 3, 3, 1, "center", "subtitle")

    if self.grid:Button("Single Player", 3, 5, 3, 1, "menu") then
      self.doExit = function () return "ingame" end
    end

    if self.grid:Button("Options", 3, 7, 3, 1, "menu") then
      -- self.doExit = function () return "titleoptions" end
    end

    if self.grid:Button("Quit", 3, 9, 1, 1, "menu") then
      love.event.push("quit")
    end

    if self.grid:Button("Credits", 5, 9, 1, 1, "menu") then
      self.doExit = function () return "credits" end
    end
  end

  function state:draw()
    self.gui.core.draw()

    if self.drawGrid then self.grid:TestDrawGrid() end
  end

  function state:keypressed(key, code)
    self.gui.core.keyboard.pressed(key, code)

    if key == "g" then
      self.drawGrid = not self.drawGrid
    end

    if key == "c" then
      self.doExit = function () return "credits" end
    end

    if key == "o" then
      self.doExit = function () return "titleoptions" end
    end

    if key == "escape" then
      love.event.push("quit")
    end

    -- print("keypressed:\t " .. self.debugName, key, code)
  end

  return state

end


