return function (state)

  function state:init()
    self.gui = require 'menu2'
    self.gui:load(gWindow.width, gWindow.height)

    self.gui.items = {
      {
        content = "Single Player",
        widget = "Button",
        size = "normal",
        row = 1,
        onAction = nullFunction,
      },
      {
        content = "Multiplayer",
        widget = "Button",
        size = "normal",
        row = 2,
        onAction = nullFunction
      },

      {
        content = "Credits",
        widget = "Button",
        size = "normal",
        row = 3,
        onAction = nullFunction
      },
      {
        content = "Options",
        widget = "LeftButton",
        size = "normal",
        row = 4,
        onAction = nullFunction
      },
      {
        content = "Quit Game",
        widget = "RightButton",
        size = "normal",
        row = 4,
        onAction = function (item) love.event.push("quit") end
      }
    }


    self.debugName = "Title Options"
    print("init:\t\t " .. self.debugName)
  end

  function state:enter(previous)
    print("enter:\t\t " .. self.debugName)
  end

  function state:leave(previous)
    self.doExit = nil
    print("leave:\t\t " .. self.debugName .. "\n")
  end

  function state:update(dt)
    if self.doExit then return self.doExit() end

    self.gui:update(dt)
  end

  function state:draw()
    self.gui:draw()
  end

  function state:keypressed(key, code)
    self.gui:keypressed(key, code)

    if key == "escape" then
      self.doExit = function () return self.parent end
    end

    print("keypressed:\t " .. self.debugName, key, code)
  end

  return state

end
